/*
 * MouseIntent jQuery Plug-in
 *
 * Copyright 2013 Giva, Inc. (http://www.givainc.com/labs/) 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * 	http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Date: 2013-10-03
 * Rev:  1.0.00
 */
(function(F){F.fn.mouseintent=function(J){var I=this;return this.each(function(M,N){var L=I.eq(M),K=L.data("mouseintent");if(!K){L.data("mouseintent",new H(I.eq(M),J)).bind("mouseintent.destroy",function(){L.removeData("mouseintent")})}})};F.mouseintent={version:"1.0.00",defaults:{borderThreshold:100,monitorMovement:true,monitorFrequency:100,mouseAwayAfter:1500,init:F.noop,mouseaway:F.noop,mousereenter:F.noop}};var C=new D();function D(I){this.items=I||[]}D.prototype.get=function(I){return this.items[I]};D.prototype.getAll=function(I){return this.items};D.prototype.count=function(I){return this.items.length};D.prototype.add=function(I){this.items.push(I)};D.prototype.remove=function(J){for(var I=0;I<this.count();I++){if(J===this.items[I]){this.items.splice(I,1);return true}}return false};var E={positions:[],isTracking:false,start:function(){if(E.isTracking){return }F(document).bind("mousemove.TrackMouse",E.eventHandler);E.isTracking=true},stop:function(){F(document).unbind("mousemove.TrackMouse");E.isTracking=false},get:function(){return{current:E.positions[E.positions.length-1],previous:E.positions[0]}},eventHandler:function(J){var I={x:J.pageX,y:J.pageY,timeStamp:(new Date).getTime()};E.positions.push(I);if(E.positions.length>3){E.positions.shift()}}};function H(K,S){var Q=this,R=K,J;E.start();C.add(Q);this.options=S=F.extend({},F.mouseintent.defaults,S);M(this.options);this.create=function(){this.updateDimensions();R.bind("mouseleave.mouseintent",function(){N()})};this.destroy=function(){C.remove(Q);if(C.count()===0){E.stop()}R.unbind(".mouseintent");R.trigger("mouseintent.destroy")};this.mouseaway=function(){S.mouseaway.apply(Q,[S]);R.trigger("mouseintent-mouseaway",[S]);this.destroy()};this.mousereenter=function(){S.mousereenter.apply(Q,[S]);R.trigger("mouseintent-mousereenter",[S])};this.updateDimensions=function(){return J=A.getDimensions(R)};function M(U){var T=U.borderThreshold;if(F.isNumeric(T)){return }if(!F.isArray(T)){throw"An invalid borderThreshold has been specified. This value must either be a numeric value or an array."}if(T.length===1){T=[T[0],T[0],T[0],T[0]]}else{if(T.length===2){T=[T[0],T[1],T[0],T[1]]}else{if(T.length===3){T=[T[0],T[1],T[2],T[1]]}}}U.borderThreshold=T}function N(V,U){var Y=(new Date()).getTime(),T=E.get(),W=!V,X=O(T.current,W),Z=!Q.options.monitorMovement||W||(T.current.timeStamp!==V.timeStamp);if(!U){U=Y}if(Z&&X.insideThreshold&&!L(U,Y)){setTimeout(function(){N(T.current,U)},Q.options.monitorFrequency)}else{if(!W&&(X.distance===-1)){Q.mousereenter()}else{Q.mouseaway()}}}function P(T){if(F.isNumeric(Q.options.borderThreshold)){return Q.options.borderThreshold}else{return Q.options.borderThreshold[T]}}function O(U,W){var X=G(J,U),V=B(J,U),T=P(V.value);return{distance:X,direction:V.value,threshold:T,isWithinThresholdContainer:I(J,U),insideThreshold:(T>0)&&((W===true)||((X>-1)&&(X<=T)&&I(J,U)))}}function I(V,U){var T={top:V.top-P(0),right:V.right+P(1),bottom:V.bottom+P(2),left:V.left-P(3)};return !(U.x<T.left||U.x>T.right||U.y<T.top||U.y>T.bottom)}function L(T,U){return(Q.options.mouseAwayAfter>0)&&((U-T)>=Q.options.mouseAwayAfter)}this.create();S.init.apply(Q,[S]);R.trigger("mouseintent-init",[S]);return this}function G(K,J){var I=J.x,L=J.y;if(J.x<K.left){I=K.left}else{if(J.x>K.right){I=K.right}}if(J.y<K.top){L=K.top}else{if(J.y>K.bottom){L=K.bottom}}return((I===J.x)&&(L===J.y))?-1:Math.floor(Math.sqrt(Math.pow(J.x-I,2)+Math.pow(J.y-L,2)))}function B(L,K){var I=(K.x-L.left-(L.width/2))*(L.width>L.height?(L.height/L.width):1),N=(K.y-L.top-(L.height/2))*(L.height>L.width?(L.width/L.height):1);var M=Math.round((((Math.atan2(N,I)*(180/Math.PI))+180)/90)+3)%4,J=(["top","right","bottom","left"])[M];return{value:M,label:J}}var A={getDimensions:function(L){var J=F(L),M=J.offset(),K=J.outerWidth(),I=J.outerHeight();return{left:M.left,right:M.left+K,top:M.top,bottom:M.top+I,width:K,height:I}}}})(jQuery);